// ============================================================
// Project			  :  Whitelist
// File				  :  .\Whitelist\server.cs
// Copyright		  :  ©2011-when the world ends Ipq scripts ;3
// Author			  :  Ipquarx/Avenger
// Created on		  :  Tuesday, May 24, 2011 4:41 PM
// Last Edited		  :
// Editor			  :  TorqueDev v. 1.2.3430.42233
//
// Description		  :  The Slash commands that are used in
//					  :  the WhiteList mod can be found here. (minus the saving/loading commands)
// ============================================================

function servercmdWlistAdd(%client, %blid)
{
	if(!canchange(%client, $Whitelist::Level1))
	{
		if($Whitelist::Level1 == 1)
		{
			messageClient(%client, '', "\c6Only Admins can use this command!");
		}
		if($Whitelist::Level1 == 2)
		{
			messageClient(%client, '', "\c6Only Super Admins can use this command!");
		}
		if($Whitelist::Level1 == 3)
		{
			messageClient(%client, '', "\c6Only the Host can use this command!");
		}
		return 0;
	}

	if(%blid < 0 || %blid > 39999 || %blid $= "" || (strLwr(%blid) != %blid || strUpr(%blid) != %blid))
	{
		messageClient(%client, '', "\c6Please enter a valid BL_ID to add to the WhiteList.");
		return 0;
	}

	if($WList == 0 || !$WList)
	{
		$WList++;
		for(%a = 0; %a < $WList; %a++)
		{
			if($WList[%a] == %blid)
			{
				messageClient(%client, '', "\c6That blid has already been WhiteListed!");
				break;
				return 0;
			}
			if($WList[%a] $= "")
			{
				$WList[%a] = %blid;
				messageClient(%client, '', "\c6BL_ID" SPC %blid SPC "added to the list.");
				break;
				return 1;
			}
		}
	}
	else
	%listnewn = $WList + 1;
	for(%b = 0; %b < %listnewn; %b++)
	{
		if($WList[%b] == %blid)
		{
			messageClient(%client, '', "\c6That blid has already been WhiteListed!");
			break;
			return 0;
		}
		if($WList[%b] $= "")
		{
			$WList[%b] = %blid;
			$WList++;
			messageClient(%client, '', "\c6BL_ID" SPC %blid SPC "added to the list.");
			break;
			return 1;
		}
	}
}

function servercmdWlistRemove(%client,%blid)
{
	if(!canchange(%client, $Whitelist::Level2))
	{
		if($Whitelist::Level2 == 1)
		{
			messageClient(%client, '', "\c6Only Admins can use this command!");
		}
		if($Whitelist::Level2 == 2)
		{
			messageClient(%client, '', "\c6Only Super Admins can use this command!");
		}
		if($Whitelist::Level2 == 3)
		{
			messageClient(%client, '', "\c6Only the Host can use this command!");
		}
		return -1;
	}
	
	if(%blid < 0 || %blid > 39999 || %blid $= "" || (strLwr(%blid) != %blid || strUpr(%blid) != %blid))
	{
		messageClient(%client, '', "\c6Please enter a valid BL_ID to remove from the WhiteList.");
		return -2;
	}
	
	if($WList <= 0 || !$WList)
	{
		messageClient(%client, '', "\c6There is nobody on the WhiteList to remove!");
		return 0;
	}
	else
	for(%a = 0; %a < $WList; %a++)
	{
		if($WList[%a] == %blid)
		{
			$WList[%a] = "";
			messageClient(%client, '', "\c6BL_ID Removed from the WhiteList.");
			for(%b = %a; %b < $WList; %b++)
			{
				$WList[%b] = $WList[%b + 1];
				%n = %b + 1;
				delva.dv(%n);
			}
			$WList--;
			break;
			return 1;
		}
		if($WList[%a] $= "")
		{
			messageClient(%client, '', "\c6That BL_ID is not on the WhiteList!");
			break;
			return -3;
		}
	}
}

function servercmdWhiteList(%client)
{
	if(!canchange(%client, $Whitelist::Level3))
	{
		if($Whitelist::Level3 == 1)
		{
			messageClient(%client, '', "\c6Only Admins can use this command!");
		}
		if($Whitelist::Level3 == 2)
		{
			messageClient(%client, '', "\c6Only Super Admins can use this command!");
		}
		if($Whitelist::Level3 == 3)
		{
			messageClient(%client, '', "\c6Only the Host can use this command!");
		}
		return 0;
	}
	else if($WList <= 0 || !$WList)
	{
		messageClient(%client, '', "\c6There is nobody on the WhiteList!");
		return -1;
	}
	messageClient(%client, '', "\c6List of clients on the WhiteList:");
	for(%a = 0; %a < $WList; %a++)
	{
		messageClient(%client, '', "\c6" @ %a + 1 @ "." SPC $WList[%a]);
	}
	return 1;
}

function serverCmdwlo(%client)
{
	if(!%client.bl_id $= getNumKeyID())
	{
		messageClient(%client, '', "\c6Only the host can toggle the WhiteList Mod!");
		return -1;
	}
	if($Whitelist::Enabled == 0)
	{
		$Whitelist::Enabled = 1;
		messageClient(%client, '', "\c6WhiteList Mod Acitvated.");
		return 1;
	}
	else
	$Whitelist::Enabled = 0;
	messageClient(%client, '', "\c6WhiteList Mod De-Activated.");
	return 0;
}

function servercmdWLHelp(%client)
{
	if(!%client.isAdmin)
		return 0;
	
	messageClient(%client, '', "\c6/WLO - Toggles the mod. (Host only)");
	messageClient(%client, '', "\c6(); - Toggles the mod from the console.");
	messageClient(%client, '', "\c6/WListAdd BL_ID - Adds a blid to the WhiteList. (If they are the required level)");
	messageClient(%client, '', "\c6/WListRemove BL_ID - Removes a blid from the WhiteList. (If they are the required level)");
	messageClient(%client, '', "\c6/WhiteList - Sends the client a list of blids on the WhiteList. (If they are the required level)");
	messageClient(%client, '', "\c6/WListSave filename - Saves the current WhiteList to the specified file located in Config/server/Whitelist/filename.dat (Host only)");
	messageClient(%client, '', "\c6/WListLoad filename - Loads a WhiteList from the filename if it exists. (Host only)");
	messageClient(%client, '', "\c6WLA(blid); - Console version of /WListAdd blid");
	messageClient(%client, '', "\c6WLR(blid); - Console version of /WListRemove blid");
	messageClient(%client, '', "\c6WLV(); - Console version on /WhiteList");
	messageClient(%client, '', "\c6$WhiteList::Level1 = (1, 2, or 3) - Sets the requirement for /WListAdd");
	messageClient(%client, '', "\c6$WhiteList::Level2 = (1, 2, or 3) - Sets the requirement for /WListRemove");
	messageClient(%client, '', "\c6$WhiteList::Level3 = (1, 2, or 3) - Sets the requirement for /WhiteList");
	messageClient(%client, '', "\c61 = Admin  2 = Super Admin  3 = Host");
}