// ============================================================
// Project			  :  Whitelist
// File				  :  .\Whitelist\server.cs
// Copyright		  :  ©2011-when the world ends Ipq scripts ;3
// Author			  :  Ipquarx/Avenger
// Created on		  :  Tuesday, May 24, 2011 4:41 PM
// Last Edited		  :
// Editor			  :  TorqueDev v. 1.2.3430.42233
//
// Description		  :  Allows super admins to make a WhiteList.
//					  :  Its like a private server, but better.
//					  :  Now with saving and loading!
//					  :  Seperated into 4 seperate files for less clutterness
//					  :  This also contains misc. console commands.
// ============================================================

exec("./SlashComs.cs");
exec("./ConComs.cs");
exec("./PackedFuncts.cs");
exec("./Saving.cs");

if(!$Whitelist::Prefs)
{
	if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
	{
		if(!$RTB::RTBR_ServerControl_Hook)
			exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
		
//		if(!$Whitelist::HostOPrefs $= 1)
//		{
		RTB_registerPref("Enabled","Whitelist","$Whitelist::Enabled","bool","Server_Whitelist",0,1,0);
//		RTB_registerPref("Host Only Prefs","Whitelist","$Whitelist::HostOPrefs","bool","Server_Whitelist",0,1,1);
		RTB_registerPref("Add to Whitelist","Whitelist","$Whitelist::Level1","list admin 1 SuperAdmin 2 Host 3","Server_WhiteList",2,0,0);
		RTB_registerPref("Remove from Whitelist","Whitelist","$Whitelist::Level2","list admin 1 SuperAdmin 2 Host 3","Server_WhiteList",2,0,0);
		RTB_registerPref("View Whitelist","Whitelist","$Whitelist::Level3","list admin 1 SuperAdmin 2 Host 3","Server_WhiteList",1,0,0);
		$Whitelist::Enabled = 0; //silly korean registry key checker (not realy, it defaults the pref to 0 because the dumb register pref dont do it itself.)
		$Whitelist::Prefs = 1;
//		}
//		else if($Whitelist::HostOPrefs $= 1)
//		{
//			RTB_registerPref("Enabled","Whitelist","$Whitelist::Enabled","bool","Server_Whitelist",0,1,0);
//			RTB_registerPref("Host Only Prefs","Whitelist","$Whitelist::HostOPrefs","bool","Server_Whitelist",0,1,1);
//			RTB_registerPref("Add to Whitelist","Whitelist","$Whitelist::Level1","list admin 1 SuperAdmin 2 Host 3","Server_WhiteList",2,1,0);
//			RTB_registerPref("Remove from Whitelist","Whitelist","$Whitelist::Level2","list admin 1 SuperAdmin 2 Host 3","Server_WhiteList",2,1,0);
//			RTB_registerPref("View Whitelist","Whitelist","$Whitelist::Level3","list admin 1 SuperAdmin 2 Host 3","Server_WhiteList",1,1,0);
//		}
	}
	else
	{
		$Whitelist::Enabled = 0; //Enable WhiteList?
		$Whitelist::Level1 = 2; //Admin level required for adding
		$Whitelist::Level2 = 2; //Admin level required for removing
		$Whitelist::Level3 = 1; //Admin level required for viewing
		$Whitelist::Prefs = 1; //Are prefs set?
	}
}

function canchange(%client, %level)
{
	if(%level == 1 && %client.isAdmin)
	{
		return 1;
	}
	if(%level == 2 && %client.isSuperAdmin)
	{
		return 1;
	}
	if(%level == 3 && %client.bl_id $= getNumKeyID())
	{
		return 1;
	}
	return 0;
}

new ScriptObject(delva);

function delva::dv(%so, %num)
{
	$WList[%num] = "";
}