// ============================================================
// Project			  :  Whitelist
// File				  :  .\Whitelist\server.cs
// Copyright		  :  ©2011-when the world ends Ipq scripts ;3
// Author			  :  Ipquarx/Avenger
// Created on		  :  Tuesday, May 24, 2011 4:41 PM
// Last Edited		  :
// Editor			  :  TorqueDev v. 1.2.3430.42233
//
// Description		  :  The Console commands that the WhiteList
//					  :  mod uses can be found here.
// ============================================================

function wlo()
{
	if($Whitelist::Enabled == 0)
	{
		$Whitelist::Enabled = 1;
		echo("WhiteList Mod Activated.");
		return 1;
	}
	else
	$Whitelist::Enabled = 0;
	echo("WhiteList Mod De-Activated.");
	return 0;
}

function WLA(%blid)
{
	if(%blid < 0 || %blid > 39999 || %blid $= "" || (strLwr(%blid) != %blid || strUpr(%blid) != %blid))
	{
		echo("Please enter a valid BL_ID to add to the WhiteList.");
		return 0;
	}

	if($WList == 0 || !$WList)
	{
		$WList++;
		for(%a = 0; %a < $WList; %a++)
		{
			if($WList[%a] == %blid)
			{
				echo("That blid has already been WhiteListed!");
				break;
				return 0;
			}
			if($WList[%a] $= "")
			{
				$WList[%a] = %blid;
				echo("BL_ID" SPC %blid SPC "added to the list.");
				break;
				return 1;
			}
		}
	}
	else
	%listnewn = $WList + 1;
	for(%b = 0; %b < %listnewn; %b++)
	{
		if($WList[%b] == %blid)
		{
			echo("That blid has already been WhiteListed!");
			break;
			return 0;
		}
		if($WList[%b] $= "")
		{
			$WList[%b] = %blid;
			$WList++;
			echo("BL_ID" SPC %blid SPC "added to the list.");
			break;
			return 1;
		}
	}
}

function WLR(%blid)
{	
	if(%blid < 0 || %blid > 39999 || %blid $= "" || (strLwr(%blid) != %blid || strUpr(%blid) != %blid))
	{
		echo("Please enter a valid BL_ID to add to the WhiteList.");
		return -2;
	}
	
	if($WList <= 0 || !$WList)
	{
		echo("There is nobody on the WhiteList to remove!");
		return 0;
	}
	else
	for(%a = 0; %a < $WList; %a++)
	{
		if($WList[%a] == %blid)
		{
			$WList[%a] = "";
			echo("BL_ID Removed from WhiteList.");
			for(%b = %a; %b < $WList; %b++)
			{
				$WList[%b] = $WList[%b + 1];
				%n = %b + 1;
				delva.dv(%n);
			}
			$WList--;
			break;
			return 1;
		}
		if($WList[%a] $= "")
		{
			echo("That BL_ID is not on the WhiteList!");
			break;
			return -3;
		}
	}
}

function WLV()
{
	if($WList <= 0 || !$WList)
	{
		echo("There is nobody on the WhiteList!");
		return 0;
	}
	
	echo("---List of clients on the WhiteList---");
	for(%a=0; %a < $WList; %a++)
	{
		echo(%a + 1 @ ". " @ $WList[%a]);
	}
	echo("---End of List---");
	return 1;
}