// ============================================================
// Project			  :  Whitelist
// File				  :  .\Whitelist\server.cs
// Copyright		  :  ©2011-when the world ends Ipq scripts ;3
// Author			  :  Ipquarx/Avenger
// Created on		  :  Tuesday, May 24, 2011 4:41 PM
// Last Edited		  :
// Editor			  :  TorqueDev v. 1.2.3430.42233
//
// Description		  :  The Packaged Functions that are used
//					  :  in the WhiteList mod can be found here.
//					  :  These functions implement the WhiteList
//					  :  features that make this mod function.
// ============================================================

deactivatePackage(WhiteList);
package WhiteList
{
	function servAuthTCPobj::onLine(%this, %line)
	{
		%c = Parent::onLine(%this, %line);
		if(getWord(%line, 0) $= "YES" && $Whitelist::Enabled == 1)
		{
			$db = getWord(%line, 1);
		}
		return %c;
	}
	function GameConnection::onConnectRequest(%this, %netAddress, %lanName, %netName, %prefix, %suffix, %int, %g, %h, %i)
	{
		%c = Parent::onConnectRequest(%this, %netAddress, %lanName, %netName, %prefix, %suffix, %int, %g, %h, %i);
		for(%a = 0; %a < $WList; %a++)
		{
			if($WList[%a] != $db && $db !$= getNumKeyID() && $Whitelist::Enabled == 1)
			{
				%NoC = %NoC + 1;
			}
			if($WList[%a] == $db)
			{
				%NoC = 0;
			}
			if(%a + 1 == $WList && %a == %NoC - 1)
			{
				return "Sorry, you're not on the WhiteList!";
				%NoC = 0;
			}
		}
		return %c;
	}
	function gameConnection::onClientEnterGame(%client)
	{
		%c = Parent::onClientEnterGame(%client);
		if(%client.bl_id $= getNumKeyID() && $Whitelist::Enabled == 0 && !$Whitelist::SpawnWMessage)
		{
			messageClient(%client, '', "\c6Welcome! Please type /WLO or find the WhiteList section of server control to toggle the WhiteList mod.");
			messageClient(%client, '', "\c6You can toggle it on and off anytime, or use the console command wlo();");
			messageClient(%client, '', "\c6Add blid's to the WhiteList by typing /WListAdd blid.");
			messageClient(%client, '', "\c6Remove blid's from the WhiteList by typing /WListRemove blid.");
			messageClient(%client, '', "\c6Type /WLHelp for more.");
			$Whitelist::SpawnWMessage = 1;
		}
		return %c;
	}
};
activatePackage(WhiteList);