// ============================================================
// Project			  :  Whitelist
// File				  :  .\Whitelist\server.cs
// Copyright		  :  ©2011-when the world ends Ipq scripts ;3
// Author			  :  Ipquarx/Avenger
// Created on		  :  Tuesday, May 24, 2011 4:41 PM
// Last Edited		  :
// Editor			  :  TorqueDev v. 1.2.3430.42233
//
// Description		  :  The Saving and Loading functions
//					  :  of the WhiteList mod are found here.
// ============================================================

$WhiteList::Path = "config/server/WhiteList/";

function serverCmdWListSave(%client, %filev)
{
	if(%client.bl_id $= getNumKeyID())
	{
		if($WList <= 0 || !$WList)
		{
			messageClient(%client, '', "\c6There is nothing on the WhiteList to save!");
			messageClient(%client, '', "\c6Please add a blid to the WhiteList before you try to save.");
			return 0;
		}
		if(!isFile($Whitelist::Path @ %filev @ ".dat"))
		{
			%file = new FileObject();
			%file.openForWrite($Whitelist::Path @ %filev @ ".dat");
			for(%a = 0; %a < $WList; %a++)
			{
				%file.WriteLine($WList[%a]);
			}
			%file.WriteLine("---ultra super mega epic bug fix line--!");
			%b = ".dat\c6.";
			%newpath = $Whitelist::Path @ %path @ %filev @ %b;
			messageClient(%client, '', "\c3WhiteList \c4" @ %filev @ "\c6 Saved to: \c2" @ %newpath);
			%file.close();
			%file.delete();
			return 1;
		}
		if(isFile($Whitelist::Path @ %filev @ ".dat") && (!%client.rep || %client.rep == 0))
		{
			messageClient(%client, '', "\c6This file already exists. If you wish to overwrite, please type the command again with the same File Name.");
			%client.rep = 1 SPC %filev;
			return -1;
		}
		if(isFile($Whitelist::Path @ %filev @ ".dat") && %client.rep == 1 SPC %filev)
		{
			%file = new FileObject();
			%file.openForWrite($Whitelist::Path @ %filev @ ".dat");
			for(%a = 0; %a < $WList; %a++)
			{
				%file.WriteLine($WList[%a]);
			}
			%file.WriteLine("---ultra super mega epic bug fix line---");
			messageClient(%client, '', "\c3WhiteList\c4" SPC %filev SPC "\c6OverWritten to:\c2" SPC $Whitelist::Path @ %filev @ ".dat\c6.");
			%file.close();
			%file.delete();
			%client.rep = 0;
			return 1;
		}
	}
	else
	messageClient(%client, '', "\c6Only the Host can use this command!");
}

function serverCmdWListLoad(%client, %filev)
{
	if(%client.bl_id $= getNumKeyID())
	{
		%newpath = $Whitelist::Path @ %filev @ ".dat\c6 Does not exist!";
		if(!isFile($Whitelist::Path @ %filev @ ".dat"))
		{
			messageClient(%client, '', "\c6The file\c4" SPC %filev @ "\c6, Path:\c2" @ %newpath);
			return -1;
		}
		if(isFile($Whitelist::Path @ %filev @ ".dat"))
		{
			deleteVariables("$WLis*");
			%file = new FileObject();
			%file.openForRead($Whitelist::Path @ %filev @ ".dat");
			$WList = -1;
			while(!%file.isEOF())
			{
				$WList[$WList++] = %file.readline();
			}
			messageClient(%client, '', "\c3WhiteList\c4" SPC %filev SPC "\c6Path:\c2" SPC $Whitelist::Path @ %filev @ ".dat\c6 Loaded.");
			%file.close();
			%file.delete();
			return 1;
		}
	}
	else
	messageClient(%client, '', "\c6Only the Host can use this command!");
}